# ZIP 打包和压缩

## 打包

打包是指将一大堆文件和目录变成一个总的文件

linux 下常用的打包工具是 tar

## 压缩

压缩则是将一个大的文件通过一些压缩算法变成一个小文件

## gzip

gzip 用于压缩单个文件, gzip 本身没有打包的功能

在 linux 下可使用 gzip 和 gunzip 压缩和解压文件

## zip

zip 同时具有打包和压缩的功能, 所以它可以直接打包压缩多个文件

在 linux 下可使用 zip 和 unzip 打包压缩和解压文件


### zip 文件的总体格式   

文件头信息+文件压缩数据   

#### 文件头信息:

| 字节数   | 描述   
| ---      | ---
| 4            | 分文件头信息标志(0x04034b50)  
| 2            | 解压缩所需版本   
| 2            | 通用比特标志位 
| 2            | 压缩方式
| 2            | 文件最后修改时间   
| 2            | 文件最后修改日期   
| 4            | 32位校验码   
| 4            | 压缩文件大小   
| 4            | 未压缩文件大小   
| 2            | 文件名长   
| 2            | 扩展段长   
| ?            | 文件名(不定长)   
| ?            | 扩展段(不定长)   
    
##### 备注

- 通用比特标志位(置比特0位=加密;置比特1位=使用压缩方式6,并使用8k变化目录,否则使用4k变化目录;置比特2位=使用压缩方式6,并使用3个ShannonFano树对变化目录输出编码,否则使用2个ShannonFano树对变化目录输出编码,其它比特位未用) 
- 压缩方式(0=不压缩,1=缩小,2=以压缩因素1缩小,3=以压缩因素2缩小,4=以压缩因素3缩小,5=以压缩因素4缩小,6=自展)